#include <dos.h>
#include <graph.h>
#include "x_dv.hpp"

#define TEXTMEMBASE	((word __far*)MK_FP(0xb800,0x0000))

textLine_t __far*textMem = (textLine_t __far*)TEXTMEMBASE;

void dv_putch(int x, int y, int ch) {
  textMem[y][x] &= 0xff00;
  textMem[y][x] += ch;
}

void dv_Aputch(int x, int y, int a, int c) {
  textMem[y][x] = (a << 8) + c;
}

void dv_WAputch(int x, int y, int c) {
  short r1, c1, r2, c2;
  word attr;
  _gettextwindow(&r1, &c1, &r2, &c2);
  attr = dv_makeAttr(_gettextcolor(), _getbkcolor());
  textMem[y + r1 - 2][x + c1 - 2] = (attr << 8) + c;
}

void dv_puts(int x, int y, char *s) {
  int i;
  word far *CAptr;
  CAptr = TEXTMEMBASE + y * 80 + x;
  for (i = 0; s[i] != 0; i++) {
    (*CAptr) &= 0xff00;
    (*CAptr) += s[i];
    CAptr++;
  }
}

void dv_Aputs(int x, int y, int a, char *s) {
  int i;
  word far *CAptr;
  CAptr = TEXTMEMBASE + y * 80 + x;
  for (i = 0; s[i] != 0; i++) {
    (*CAptr) = (a << 8) + s[i];
    CAptr++;
  }
}

void dv_setAttr(int l, int t, int r, int b, int a) {
  int x, y;
  for (y = t - 1; y < b; y++) {
    for (x = l - 1; x < r; x++) {
      textMem[y][x] &= 0x00ff;
      textMem[y][x] += a << 8;
    }
  }
}

int dv_getAttr(int x, int y) {
  return (textMem[y - 1][x - 1] & 0xff00) >> 8;
}

int dv_makeAttr(int fg, int bg) {
  return (bg << 4) | fg;
}

word dv_makeCApair(int c, int a) {
  return (a << 8) + c;
}

void dv_saveScreen(word ***screen) {
  int x, y;
  *screen = new word*[50];
  for (y = 0; y < 50; y++) {
    (*screen)[y] = new word[80];
    for (x = 0; x < 80; x++)
      (*screen)[y][x] = textMem[y][x];
  }
}

void dv_restoreScreen(word **screen) {
  int x, y;
  for (y = 0; y < 50; y++) {
    for (x = 0; x < 80; x++)
      textMem[y][x] = screen[y][x];
    delete screen[y];
  }
  delete screen;
}
